# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ibeo_msgs/ObjectData2280.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy
import ibeo_msgs.msg
import std_msgs.msg

class ObjectData2280(genpy.Message):
  _md5sum = "1feafc06b87a8faddd462af2854382a1"
  _type = "ibeo_msgs/ObjectData2280"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """Header header

IbeoDataHeader ibeo_header
time mid_scan_timestamp
uint16 number_of_objects
Object2280[] objects

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: ibeo_msgs/IbeoDataHeader
uint32 previous_message_size
uint32 message_size
uint8 device_id
uint16 data_type_id
time stamp

================================================================================
MSG: ibeo_msgs/Object2280
uint16 id
uint8 tracking_model
bool mobility_of_dyn_object_detected
bool motion_model_validated
uint32 object_age
time timestamp
uint16 object_prediction_age
uint8 classification
uint8 classification_certainty
uint32 classification_age
Point2Df object_box_center
Point2Df object_box_center_sigma
Point2Df object_box_size
float32 object_box_orientation_angle
float32 object_box_orientation_angle_sigma
Point2Df relative_velocity
Point2Df relative_velocity_sigma
Point2Df absolute_velocity
Point2Df absolute_velocity_sigma
uint8 number_of_contour_points
uint8 closest_point_index
uint16 reference_point_location
Point2Df reference_point_coordinate
Point2Df reference_point_coordinate_sigma
float32 reference_point_position_correction_coefficient
uint16 object_priority
float32 object_existence_measurement
Point2Df[] contour_point_list

# tracking_model values
uint8 DYNAMIC_MODEL=0
uint8 STATIC_MODEL=1

# classification values
uint8 UNCLASSIFIED=0
uint8 UNKNOWN_SMALL=1
uint8 UNKNOWN_BIG=2
uint8 PEDESTRIAN=3
uint8 BIKE=4
uint8 CAR=5
uint8 TRUCK=6
uint8 UNDER_DRIVABLE=12
uint8 OVER_DRIVABLE=13

# reference_point_location values
uint16 CENTER_OF_GRAVITY=0
uint16 FRONT_LEFT=1
uint16 FRONT_RIGHT=2
uint16 REAR_RIGHT=3
uint16 REAR_LEFT=4
uint16 FRONT_CENTER=5
uint16 RIGHT_CENTER=6
uint16 REAR_CENTER=7
uint16 LEFT_CENTER=8
uint16 OBJECT_CENTER=9
uint16 UNKNOWN=255


================================================================================
MSG: ibeo_msgs/Point2Df
float32 x
float32 y
"""
  __slots__ = ['header','ibeo_header','mid_scan_timestamp','number_of_objects','objects']
  _slot_types = ['std_msgs/Header','ibeo_msgs/IbeoDataHeader','time','uint16','ibeo_msgs/Object2280[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,ibeo_header,mid_scan_timestamp,number_of_objects,objects

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ObjectData2280, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.ibeo_header is None:
        self.ibeo_header = ibeo_msgs.msg.IbeoDataHeader()
      if self.mid_scan_timestamp is None:
        self.mid_scan_timestamp = genpy.Time()
      if self.number_of_objects is None:
        self.number_of_objects = 0
      if self.objects is None:
        self.objects = []
    else:
      self.header = std_msgs.msg.Header()
      self.ibeo_header = ibeo_msgs.msg.IbeoDataHeader()
      self.mid_scan_timestamp = genpy.Time()
      self.number_of_objects = 0
      self.objects = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_2IBH4IH().pack(_x.ibeo_header.previous_message_size, _x.ibeo_header.message_size, _x.ibeo_header.device_id, _x.ibeo_header.data_type_id, _x.ibeo_header.stamp.secs, _x.ibeo_header.stamp.nsecs, _x.mid_scan_timestamp.secs, _x.mid_scan_timestamp.nsecs, _x.number_of_objects))
      length = len(self.objects)
      buff.write(_struct_I.pack(length))
      for val1 in self.objects:
        _x = val1
        buff.write(_get_struct_H3BI().pack(_x.id, _x.tracking_model, _x.mobility_of_dyn_object_detected, _x.motion_model_validated, _x.object_age))
        _v1 = val1.timestamp
        _x = _v1
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = val1
        buff.write(_get_struct_H2BI().pack(_x.object_prediction_age, _x.classification, _x.classification_certainty, _x.classification_age))
        _v2 = val1.object_box_center
        _x = _v2
        buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _v3 = val1.object_box_center_sigma
        _x = _v3
        buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _v4 = val1.object_box_size
        _x = _v4
        buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _x = val1
        buff.write(_get_struct_2f().pack(_x.object_box_orientation_angle, _x.object_box_orientation_angle_sigma))
        _v5 = val1.relative_velocity
        _x = _v5
        buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _v6 = val1.relative_velocity_sigma
        _x = _v6
        buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _v7 = val1.absolute_velocity
        _x = _v7
        buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _v8 = val1.absolute_velocity_sigma
        _x = _v8
        buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _x = val1
        buff.write(_get_struct_2BH().pack(_x.number_of_contour_points, _x.closest_point_index, _x.reference_point_location))
        _v9 = val1.reference_point_coordinate
        _x = _v9
        buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _v10 = val1.reference_point_coordinate_sigma
        _x = _v10
        buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _x = val1
        buff.write(_get_struct_fHf().pack(_x.reference_point_position_correction_coefficient, _x.object_priority, _x.object_existence_measurement))
        length = len(val1.contour_point_list)
        buff.write(_struct_I.pack(length))
        for val2 in val1.contour_point_list:
          _x = val2
          buff.write(_get_struct_2f().pack(_x.x, _x.y))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.ibeo_header is None:
        self.ibeo_header = ibeo_msgs.msg.IbeoDataHeader()
      if self.mid_scan_timestamp is None:
        self.mid_scan_timestamp = genpy.Time()
      if self.objects is None:
        self.objects = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 29
      (_x.ibeo_header.previous_message_size, _x.ibeo_header.message_size, _x.ibeo_header.device_id, _x.ibeo_header.data_type_id, _x.ibeo_header.stamp.secs, _x.ibeo_header.stamp.nsecs, _x.mid_scan_timestamp.secs, _x.mid_scan_timestamp.nsecs, _x.number_of_objects,) = _get_struct_2IBH4IH().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.objects = []
      for i in range(0, length):
        val1 = ibeo_msgs.msg.Object2280()
        _x = val1
        start = end
        end += 9
        (_x.id, _x.tracking_model, _x.mobility_of_dyn_object_detected, _x.motion_model_validated, _x.object_age,) = _get_struct_H3BI().unpack(str[start:end])
        val1.mobility_of_dyn_object_detected = bool(val1.mobility_of_dyn_object_detected)
        val1.motion_model_validated = bool(val1.motion_model_validated)
        _v11 = val1.timestamp
        _x = _v11
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        _x = val1
        start = end
        end += 8
        (_x.object_prediction_age, _x.classification, _x.classification_certainty, _x.classification_age,) = _get_struct_H2BI().unpack(str[start:end])
        _v12 = val1.object_box_center
        _x = _v12
        start = end
        end += 8
        (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
        _v13 = val1.object_box_center_sigma
        _x = _v13
        start = end
        end += 8
        (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
        _v14 = val1.object_box_size
        _x = _v14
        start = end
        end += 8
        (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
        _x = val1
        start = end
        end += 8
        (_x.object_box_orientation_angle, _x.object_box_orientation_angle_sigma,) = _get_struct_2f().unpack(str[start:end])
        _v15 = val1.relative_velocity
        _x = _v15
        start = end
        end += 8
        (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
        _v16 = val1.relative_velocity_sigma
        _x = _v16
        start = end
        end += 8
        (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
        _v17 = val1.absolute_velocity
        _x = _v17
        start = end
        end += 8
        (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
        _v18 = val1.absolute_velocity_sigma
        _x = _v18
        start = end
        end += 8
        (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
        _x = val1
        start = end
        end += 4
        (_x.number_of_contour_points, _x.closest_point_index, _x.reference_point_location,) = _get_struct_2BH().unpack(str[start:end])
        _v19 = val1.reference_point_coordinate
        _x = _v19
        start = end
        end += 8
        (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
        _v20 = val1.reference_point_coordinate_sigma
        _x = _v20
        start = end
        end += 8
        (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
        _x = val1
        start = end
        end += 10
        (_x.reference_point_position_correction_coefficient, _x.object_priority, _x.object_existence_measurement,) = _get_struct_fHf().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.contour_point_list = []
        for i in range(0, length):
          val2 = ibeo_msgs.msg.Point2Df()
          _x = val2
          start = end
          end += 8
          (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
          val1.contour_point_list.append(val2)
        self.objects.append(val1)
      self.mid_scan_timestamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_2IBH4IH().pack(_x.ibeo_header.previous_message_size, _x.ibeo_header.message_size, _x.ibeo_header.device_id, _x.ibeo_header.data_type_id, _x.ibeo_header.stamp.secs, _x.ibeo_header.stamp.nsecs, _x.mid_scan_timestamp.secs, _x.mid_scan_timestamp.nsecs, _x.number_of_objects))
      length = len(self.objects)
      buff.write(_struct_I.pack(length))
      for val1 in self.objects:
        _x = val1
        buff.write(_get_struct_H3BI().pack(_x.id, _x.tracking_model, _x.mobility_of_dyn_object_detected, _x.motion_model_validated, _x.object_age))
        _v21 = val1.timestamp
        _x = _v21
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = val1
        buff.write(_get_struct_H2BI().pack(_x.object_prediction_age, _x.classification, _x.classification_certainty, _x.classification_age))
        _v22 = val1.object_box_center
        _x = _v22
        buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _v23 = val1.object_box_center_sigma
        _x = _v23
        buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _v24 = val1.object_box_size
        _x = _v24
        buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _x = val1
        buff.write(_get_struct_2f().pack(_x.object_box_orientation_angle, _x.object_box_orientation_angle_sigma))
        _v25 = val1.relative_velocity
        _x = _v25
        buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _v26 = val1.relative_velocity_sigma
        _x = _v26
        buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _v27 = val1.absolute_velocity
        _x = _v27
        buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _v28 = val1.absolute_velocity_sigma
        _x = _v28
        buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _x = val1
        buff.write(_get_struct_2BH().pack(_x.number_of_contour_points, _x.closest_point_index, _x.reference_point_location))
        _v29 = val1.reference_point_coordinate
        _x = _v29
        buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _v30 = val1.reference_point_coordinate_sigma
        _x = _v30
        buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _x = val1
        buff.write(_get_struct_fHf().pack(_x.reference_point_position_correction_coefficient, _x.object_priority, _x.object_existence_measurement))
        length = len(val1.contour_point_list)
        buff.write(_struct_I.pack(length))
        for val2 in val1.contour_point_list:
          _x = val2
          buff.write(_get_struct_2f().pack(_x.x, _x.y))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.ibeo_header is None:
        self.ibeo_header = ibeo_msgs.msg.IbeoDataHeader()
      if self.mid_scan_timestamp is None:
        self.mid_scan_timestamp = genpy.Time()
      if self.objects is None:
        self.objects = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 29
      (_x.ibeo_header.previous_message_size, _x.ibeo_header.message_size, _x.ibeo_header.device_id, _x.ibeo_header.data_type_id, _x.ibeo_header.stamp.secs, _x.ibeo_header.stamp.nsecs, _x.mid_scan_timestamp.secs, _x.mid_scan_timestamp.nsecs, _x.number_of_objects,) = _get_struct_2IBH4IH().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.objects = []
      for i in range(0, length):
        val1 = ibeo_msgs.msg.Object2280()
        _x = val1
        start = end
        end += 9
        (_x.id, _x.tracking_model, _x.mobility_of_dyn_object_detected, _x.motion_model_validated, _x.object_age,) = _get_struct_H3BI().unpack(str[start:end])
        val1.mobility_of_dyn_object_detected = bool(val1.mobility_of_dyn_object_detected)
        val1.motion_model_validated = bool(val1.motion_model_validated)
        _v31 = val1.timestamp
        _x = _v31
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        _x = val1
        start = end
        end += 8
        (_x.object_prediction_age, _x.classification, _x.classification_certainty, _x.classification_age,) = _get_struct_H2BI().unpack(str[start:end])
        _v32 = val1.object_box_center
        _x = _v32
        start = end
        end += 8
        (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
        _v33 = val1.object_box_center_sigma
        _x = _v33
        start = end
        end += 8
        (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
        _v34 = val1.object_box_size
        _x = _v34
        start = end
        end += 8
        (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
        _x = val1
        start = end
        end += 8
        (_x.object_box_orientation_angle, _x.object_box_orientation_angle_sigma,) = _get_struct_2f().unpack(str[start:end])
        _v35 = val1.relative_velocity
        _x = _v35
        start = end
        end += 8
        (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
        _v36 = val1.relative_velocity_sigma
        _x = _v36
        start = end
        end += 8
        (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
        _v37 = val1.absolute_velocity
        _x = _v37
        start = end
        end += 8
        (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
        _v38 = val1.absolute_velocity_sigma
        _x = _v38
        start = end
        end += 8
        (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
        _x = val1
        start = end
        end += 4
        (_x.number_of_contour_points, _x.closest_point_index, _x.reference_point_location,) = _get_struct_2BH().unpack(str[start:end])
        _v39 = val1.reference_point_coordinate
        _x = _v39
        start = end
        end += 8
        (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
        _v40 = val1.reference_point_coordinate_sigma
        _x = _v40
        start = end
        end += 8
        (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
        _x = val1
        start = end
        end += 10
        (_x.reference_point_position_correction_coefficient, _x.object_priority, _x.object_existence_measurement,) = _get_struct_fHf().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.contour_point_list = []
        for i in range(0, length):
          val2 = ibeo_msgs.msg.Point2Df()
          _x = val2
          start = end
          end += 8
          (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
          val1.contour_point_list.append(val2)
        self.objects.append(val1)
      self.mid_scan_timestamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_fHf = None
def _get_struct_fHf():
    global _struct_fHf
    if _struct_fHf is None:
        _struct_fHf = struct.Struct("<fHf")
    return _struct_fHf
_struct_H3BI = None
def _get_struct_H3BI():
    global _struct_H3BI
    if _struct_H3BI is None:
        _struct_H3BI = struct.Struct("<H3BI")
    return _struct_H3BI
_struct_2BH = None
def _get_struct_2BH():
    global _struct_2BH
    if _struct_2BH is None:
        _struct_2BH = struct.Struct("<2BH")
    return _struct_2BH
_struct_2f = None
def _get_struct_2f():
    global _struct_2f
    if _struct_2f is None:
        _struct_2f = struct.Struct("<2f")
    return _struct_2f
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_2IBH4IH = None
def _get_struct_2IBH4IH():
    global _struct_2IBH4IH
    if _struct_2IBH4IH is None:
        _struct_2IBH4IH = struct.Struct("<2IBH4IH")
    return _struct_2IBH4IH
_struct_H2BI = None
def _get_struct_H2BI():
    global _struct_H2BI
    if _struct_H2BI is None:
        _struct_H2BI = struct.Struct("<H2BI")
    return _struct_H2BI
_struct_2I = None
def _get_struct_2I():
    global _struct_2I
    if _struct_2I is None:
        _struct_2I = struct.Struct("<2I")
    return _struct_2I
